const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const relatorio_andamento_atual = sequelize.define(
    'relatorio_andamento_atual',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      data_ultima_atualizacao: {
        type: DataTypes.DATE,
      },

      status_obra: {
        type: DataTypes.TEXT,
      },

      percentual_execucao_total: {
        type: DataTypes.DECIMAL,
      },

      atividade_atual_predominante: {
        type: DataTypes.TEXT,
      },

      riscos_em_aberto: {
        type: DataTypes.TEXT,
      },

      tempo_estimado_para_conclusao: {
        type: DataTypes.TEXT,
      },

      grau_conformidade_geral: {
        type: DataTypes.TEXT,
      },

      observacoes_finais: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  relatorio_andamento_atual.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.relatorio_andamento_atual.belongsTo(db.obras, {
      as: 'obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    db.relatorio_andamento_atual.belongsTo(db.relatorios_analiticos_video, {
      as: 'ultimo_relatorio_video',
      foreignKey: {
        name: 'ultimo_relatorio_videoId',
      },
      constraints: false,
    });

    db.relatorio_andamento_atual.belongsTo(db.clientes, {
      as: 'clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.relatorio_andamento_atual.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.relatorio_andamento_atual.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return relatorio_andamento_atual;
};
